#store this file as a module? 
#Initialise cup - only normal vector 
#record vector position into a data frame as postion 0
from pyquaternion import Quaternion
import numpy as np
# To display the figure defined by this dict, use the low-level plotly.io.show function
import plotly.graph_objs as go

from plotly.offline import plot
import plotly.figure_factory as ff
import math 
from numpy import linalg as LA

def rotateCup(vector_data, rotation_axis, rotation_angle_deg):  #vector data must be np.array
    
    if isinstance(vector_data, np.ndarray):

        rotation_quaternion = Quaternion(axis = rotation_axis, angle=math.radians(rotation_angle_deg))
        # print(math.radians(rotation_angle_deg))
        if isinstance(vector_data[0], np.float64):
            result = rotation_quaternion.rotate(vector_data) 
        else: 
            result_raw = [rotation_quaternion.rotate(x) for x in vector_data]
            result = np.stack(result_raw, axis=0 )
    
    return result

def random_color():
    color = [np.random.randint(50, 200), np.random.randint(50, 200), np.random.randint(50, 200)]
    return ('rgb' + str(tuple(color)))

def traceQuiver3D(figure_name, vector, plot_color, trace_name = 'undefined'): #plots one vector - if more needed use this in for loop? origin zero only
    unit_vector = vector/LA.norm(vector)
    figure_name.add_trace(go.Cone(x = [vector[0]], y = [vector[1]], z = [vector[2]], u = [unit_vector[0]], v = [unit_vector[1]], w = [unit_vector[2]], name = trace_name,
                            showscale=False, showlegend=True, colorscale = [[0, plot_color], [1, plot_color]]))
    figure_name.add_trace(go.Scatter3d(x=[0, vector[0]], y = [0, vector[1]], z = [0, vector[2]], name = trace_name,mode='lines', line_color = plot_color))
    figure_name.update_layout(
        scene = dict(
            xaxis = dict(nticks=4, range=[-2,2],),
                     yaxis = dict(nticks=4, range=[-2,2],),
                     zaxis = dict(nticks=4, range=[-2,2])))     

def traceQuivers3D(figure_name, vector_array, start, finish, trace_name_1 = 'undefined'):
    color_trace = random_color()
    [traceQuiver3D(figure_name, x, color_trace, trace_name_1) for x in vector_array[start:finish][:]]

if (__name__ == '__main__'):
    fig = go.Figure()
    rotated_vector = rotateCup(np.array([[0., 0., -1.], [1., 0., 0.]]), [0., 1., 0], (90))
    traceQuivers3D(fig, rotated_vector,  0, len(rotated_vector))
    print(rotated_vector)
    rotated_vector = rotateCup(rotated_vector, rotated_vector[1], (10))
    print(rotated_vector)
    

    #traceQuivers3D(fig, rotated_vector,  0, len(rotated_vector))
    # traceQuivers3D(fig, np.array([0., 0., -1.]), random_color())
    #plot(fig, filename='c:/users/ksesh/'+'test.html', auto_open=True)