

# function to iterate angles around 3 axis -> for each time point output vector 
# save results to text file?  or to nd.array or to pandas dataframe

import numpy as np 

import CupInitialPostion as cip

import pandas as pd


def readRotationFile(file_name, sheet_number, column_number_x, column_number_y, column_number_z, skip_rows = None):
    df_trial_angles = pd.read_excel(file_name, sheet_name = sheet_number, header = None, skiprows = [skip_rows] )
    new_array = df_trial_angles.to_numpy()
    rotation_angles_x = np.asarray([i[column_number_x] for i in new_array])
    rotation_angles_y = np.asarray([i[column_number_y] for i in new_array])
    rotation_angles_z = np.asarray([i[column_number_z] for i in new_array])

    rotation_array = np.array([rotation_angles_x.ravel(), rotation_angles_y.ravel(), rotation_angles_z.ravel()])

    return rotation_array

def iterationRotate(first_angle, second_angle, third_angle, first_axis, second_axis, third_axis, vector_to_process, k = 500):
    first_it = first_angle/k
    second_it = second_angle/k
    third_it = third_angle/k
    first_total = 0

    vector_final = vector_to_process
    i = 0

    while i < k:
        first_total = first_total + first_it
        first_rotation_vec = cip.rotateCup(vector_final, first_axis, first_it)
        second_rotation_vec = cip.rotateCup(first_rotation_vec, second_axis, second_it)
        third_rotation_vec = cip.rotateCup(second_rotation_vec, third_axis, third_it)
        vector_final = third_rotation_vec
        i += 1

    vector_final = [round(vector_final[0], 4), round(vector_final[1], 4), round(vector_final[2], 4)]    
    return vector_final

def batchIterationRotate(vector_to_process, rotation_file, sheet_number, column_number_x, column_number_y, column_number_z, results_file, skip_rows = None):
    x, y, z = readRotationFile(rotation_file, sheet_number, column_number_x, column_number_y, column_number_z, skip_rows)
    x_axis = [1., 0., 0.]
    y_axis = [0., 1., 0.]
    z_axis = [0., 0., 1.]

    i = 0
    df_results = pd.DataFrame(columns=['x', 'y', 'z'])
    
    while i < len(x): 
        result = iterationRotate(x[i], y[i], z[i], x_axis, y_axis, z_axis, vector_to_process)
        df = pd.DataFrame([result],
                   columns=['x', 'y', 'z'])
        df_results = df_results.append(df, ignore_index=True)

        i += 1
    else: 
        print('done')
    df_results.to_json(results_file, orient='split')
    return df_results

if (__name__ == '__main__'):
    
    #x, y, z = readRotationFile('test_iter.xlsx', 0, 0, 1, 2)
    #result = [iterationRotate(x[i], y[i], z[i], np.array([0., 0., 1])) for i in range(0, len(x))]
    
    #result = batchIterationRotate(np.array([1., 0., 0.]), 'test_iter.xlsx', 'output.json')
    result = readRotationFile('025.xlsx', 3, 4, 5, 6, 0)
    
        


#saving files example
#x = y = z = np.arange(0.0,5.0,1.0)
#print(x)
#np.savetxt('test.out', x, delimiter=',')   # X is an array
#np.savetxt('test.txt', (x,y,z))   # x,y,z equal sized 1D arrays
#np.savetxt('test.out', x, fmt='%1.4e')   # use exponential notation