
import pandas as pd
import json
import itertools
import collections
import statistics

# load each trial json as a data frame - change version to inclination or vice versa (the naming will depend on naming in "LimitsAnalysis.py"). 
file_list = ['version_wt_avetrial1_limits_all_patients.json', 'version_wt_avetrial2_limits_all_patients.json', 'version_wt_avetrial3_limits_all_patients.json', 'version_wt_avetrial4_limits_all_patients.json']

def Convert(lst, index): 
    res_dct = {lst[i]: lst[i + index] for i in range(0, len(lst), 4)} 
    return res_dct

def readJson(file_name):
    json1_file = open(file_name)
    json1_str = json1_file.read()
    json1_data = json.loads(json1_str)
    merged = list(itertools.chain(*json1_data['data']))
    return merged 

def mergeDict(dict1, dict2):
   ''' Merge dictionaries and keep values of common keys in list'''
   dict3 = {**dict1, **dict2}
   for key, value in dict3.items():
       if key in dict1 and key in dict2:
               dict3[key] = [value , dict1[key]]
 
   return dict3

def flatten(x):
    if isinstance(x, collections.Iterable):
        return [a for i in x for a in flatten(i)]
    else:
        return [x]

def findLimits(patient, limit, dictionary): 
    limit1 = limit
    a = flatten(dictionary[patient])
    print(a)

    if limit1 == 'min':
        result = min(a)
    elif limit1 == 'ave':
        result = statistics.mean(a)
    else:
        result = max(a)
    return result

new_min_dict = {}
new_max_dict = {}
new_ave_dict = {}
folder = r'M:\3. Python Projects\test-folder\paper-code\analysis\\' 

for file in file_list:
    merged = readJson(folder + file)
    min_dict = Convert(merged, 1)
    max_dict = Convert(merged, 2)
    ave_dict = Convert(merged, 3)
    new_min_dict = mergeDict(new_min_dict, min_dict)
    new_max_dict = mergeDict(new_max_dict, max_dict)
    new_ave_dict = mergeDict(new_ave_dict, ave_dict)

all_trials_df = pd.DataFrame(columns = ['patient', 'min', 'max', 'ave'])

for key in new_min_dict:
    min_of_min = findLimits(key, 'min', new_min_dict)
    max_of_max = findLimits(key, 'max', new_max_dict)
    ave_of_ave = findLimits(key, 'ave', new_ave_dict)
    d = {'patient': [key], 'min': [min_of_min], 'max' : [max_of_max], 'ave' : [ave_of_ave]}
    output = pd.DataFrame(d)
    all_trials_df = pd.concat([all_trials_df, output], ignore_index=True)

all_trials_df.to_json(str(folder + 'all_trials_verionswt_ave.json'), orient = 'split') # change naming as required
all_trials_df.to_csv(str(folder + 'all_trials_versionwt_ave.csv'), index = False) # change naming as required
    



