# Ksenija Vasiljeva 02/12/2021
# 


from RecordMeanFiles import averageTrials
from os import listdir 
from os.path import isfile, join
from statistics import mean, median, mode
import matplotlib.pyplot as plt

def save_image(fname):
    #save imgae
    plt.savefig(fname, dpi=320, facecolor='w', edgecolor='w', orientation='landscape',papertype=None, 
                              format=None, transparent=False, bbox_inches='tight')



patient_HF = ['001', '002', '025', '026', '042', '050', '052', '073', '075', 
        '084', '086', '093', '094', '114', 
            '116', '118', '120', '131', '148', '151']
patient_LF = ['021', '024', '032', '063', '066', '078',
        '102', '119', '126', '133', '008', '069', '085', '089',
        '100', '112', '115', '117', '136']

    
folder_orientation = r'M:\3. Python Projects\test-folder\paper-code\\' # folder with output from "MAIN.py"
available_files = [files for files in listdir(folder_orientation) if isfile(join(folder_orientation, files))]
available_files = [x for x in available_files if 'angles_results.json' in x] # include only angle results 

fig = plt.figure()
ax = plt.axes()

function = patient_HF
HF_list_inc = []
HF_min_list_inc = []
HF_max_list_inc = []
HF_range_inc = []

HF_list_ver = []
HF_min_list_ver = []
HF_max_list_ver = []
HF_range_ver = []

for i in range(0, len(function)):
        x_data = averageTrials(function[i], available_files, 'version', folder_orientation)
        y_data = averageTrials(function[i], available_files, 'inclination', folder_orientation)

        HF_list_ver.append(mean(x_data))
        HF_min_list_ver.append(mean(x_data) - x_data.min())
        HF_max_list_ver.append(x_data.max() - mean(x_data))

        HF_list_inc.append(mean(y_data))
        HF_min_list_inc.append(mean(y_data) - y_data.min())
        HF_max_list_inc.append(y_data.max() - mean(y_data))

        HF_range_ver.append(x_data.max() - x_data.min())
        HF_range_inc.append(y_data.max() - y_data.min())



x_error = [HF_min_list_ver, HF_max_list_ver]        
y_error = [HF_min_list_inc, HF_max_list_inc]  

ax1 = ax.errorbar(HF_list_ver, HF_list_inc, xerr=x_error, yerr=y_error, elinewidth=0.3, capsize=1.5, fmt='o', color = 'k')



function = patient_LF
LF_list_inc = []
LF_min_list_inc = []
LF_max_list_inc = []
LF_range_ver = []

LF_list_ver = []
LF_min_list_ver = []
LF_max_list_ver = []
LF_range_inc = []

for i in range(0, len(function)):
        x_data = averageTrials(function[i], available_files, 'version', folder_orientation)
        y_data = averageTrials(function[i], available_files, 'inclination', folder_orientation)

        LF_list_ver.append(mean(x_data))
        LF_min_list_ver.append(mean(x_data) - x_data.min())
        LF_max_list_ver.append(x_data.max() - mean(x_data))

        LF_list_inc.append(mean(y_data))
        LF_min_list_inc.append(mean(y_data) - y_data.min())
        LF_max_list_inc.append(y_data.max() - mean(y_data))

        LF_range_ver.append(x_data.max() - x_data.min())
        LF_range_inc.append(y_data.max() - y_data.min())




x_error = [LF_min_list_ver, LF_max_list_ver]        
y_error = [LF_min_list_inc, LF_max_list_inc]  

ax2 = ax.errorbar(LF_list_ver, LF_list_inc, xerr=x_error, yerr=y_error, elinewidth=0.3, capsize=1.5, fmt='o', color = 'r')

font = {'family' : 'arial',
        'weight' : 'bold',
        'size'   : 22}
ax.set_xlabel('Version Angle  [$^o$]', fontdict = font)
ax.set_ylabel('Inclination Angle  [$^o$]', fontdict = font)
plt.xticks(fontsize=16)
plt.yticks(fontsize=16)
plt.title('Inclination Angle, Mean and SD', fontdict = font)

ax.legend([ax1, ax2], ['Fast Walking', 'Slow Walking'], loc='upper right', fontsize=14)
plt.grid(b=True, color='grey', linestyle='--', linewidth=0.5, alpha=0.5)

ax.set_ylim([35, 55])
ax.set_xlim([-25, 25])
ax.set_title('')

save_image(folder_orientation + 'analysis\\IncVsVer.png')
plt.show()

inclination_list = HF_list_inc + LF_list_inc
print(mean(inclination_list), median(inclination_list))

version_list = HF_list_ver + LF_list_ver
print(mean(version_list), median(version_list))

range_inc = HF_range_inc + LF_range_inc
print(min(range_inc), max(range_inc))

range_ver = HF_range_ver + LF_range_ver
print(min(range_ver), max(range_ver))