from os import listdir
from os.path import isfile, join
import json
import numpy as np
import pandas as pd

# extracting data for each patient in patient list
def extractJson(file_name, angle_name):
    # read json file
    data = pd.read_json(file_name, orient='split')
    # extract angle (version or inclination) 
    data = data[angle_name]
    return data

# calculates average for each trial for one patient
def averageTrials(patient_name, file_list, angle_name, folder):
    file_list_patient = [x for x in file_list if patient_name in x]
    data_list_trial = list(map(lambda x : extractJson(folder+x, angle_name), file_list_patient))
    df_data_trial = pd.DataFrame(data_list_trial).transpose()
    df_average = df_data_trial.mean(axis=1)
    return(df_average)

# average results for cup orientation put in the row in pd
def averagesOrientation(file_list, function, angle_name, folder): 
    function_file_list = []
    for i in range(len(function)):
        l = [x for x in file_list if function[i] in x] 
        function_file_list.extend(l)


    data = list(map(lambda x : averageTrials(str(x), function_file_list, angle_name, folder), function))
    df_data = pd.DataFrame(data).transpose()
    return(df_data)


# calculates average across all trials for each patient, and records data for all patients into 1 np.array
def averageOreintationTrialsPatients(folder_orientation, current_dir, function, angle_name): 

    available_files = [files for files in listdir(current_dir + folder_orientation) if isfile(join(current_dir + folder_orientation, files))]
    available_files = [x for x in available_files if 'angles_results.json' in x] # include only angle results 
    a = averagesOrientation(available_files, function, angle_name, current_dir+folder_orientation)
        
    return a

def load_tester(path):
    with open(path) as f:
        data = json.load(f)
    return np.asarray(data)

HF = ['001', '002', '025', '026', '042', '050', '052', '073', '075', 
        '084', '086', '093', '094', '114', 
            '116', '118', '120', '131', '148', '151']
LF = ['021', '024', '032', '063', '066', '078',
        '102', '119', '126', '133', '008', '069', '085', '089',
        '100', '112', '115', '117', '136']

folder = r'M:\3. Python Projects\test-folder\paper-code\\'


# below change LF to HF and vice versa, and change inclination to version and vice versa
output = averageOreintationTrialsPatients('', folder, LF, 'version') # left 'folder orientation' (argument to function) 
                                                                        # empty but might be required if analysing different cup orientations and using subfolders

output.to_json(folder+ 'analysis\\VersionLFmean.json', orient="split")


