# Ksenija Vasiljeva 02/12/2021
# Recording avrage of trials for patient pelvic motions (tilt, obliquity, internal-external rotation)


from os import listdir
from os.path import isfile, join
import pandas as pd 


def extractXls(file_name, motion_name):
    # read json file
    data = pd.read_excel(file_name)
    # extract angle (version or inclination) 
    data = data[motion_name]
    return data

# read averages for pelvic motions put in the row in pd
def averagesMotions(file_list, function, angle, folder):
    function_file_list = []
    for i in range(len(function)):
        l = [x for x in file_list if function[i] in x] 
        function_file_list.extend(l)


    data = list(map(lambda x : extractXls(folder+str(x), angle), function_file_list)) #chage to folder_motions if shows error
    df_data = pd.DataFrame(data).transpose()
    return(df_data)

# calculates average across all trials for each patient, and records data for all patients into 1 np.array
def averageMotionsPatients(current_dir, function, angle_name): 

    available_files = [files for files in listdir(current_dir) if isfile(join(current_dir, files))]
    available_files = [x for x in available_files if 'Average_To' in x] # include only average angle results 
    a = averagesMotions(available_files, function, angle_name, current_dir)
        
    return a


HF = ['001', '002', '025', '026', '042', '050', '052', '073', '075', 
        '084', '086', '093', '094',  '114', 
            '116', '118', '120', '131', '148', '151']
LF = ['021', '024', '032', '063', '066', '078',
        '102', '119', '126', '133', '008', '069', '085', '089',
        '100', '112', '115', '117', '136']



# below change LF to HF and vice versa, and change OPA/TPA/IEPA
# averaged out pelvic movement data (format "average-pelvis-example.xlsx") from raw patient data that was combined and normalised to right hip for "MAIN.py" input :
folder = r'C:\Users\menkva\OneDrive - University of Leeds\0. HIPhip Research Fellow - private\1. Research Fellow iMBE\4. LBRC Visualisation Gait & Static Data\3. Data For Visualisation\\' 

output = averageMotionsPatients(folder, HF, 'OPA') # change arguments here

output.to_json(r'M:\3. Python Projects\test-folder\paper-code\analysis\OPAAverageHF.json', orient="split") # change arguments here

# below check data - comment out if trying to save time
data = pd.read_json(r'M:\3. Python Projects\test-folder\paper-code\analysis\OPAAverageHF.json', orient='split') # change arguments here
print(data)
np_data = data.to_numpy()
print(np_data)